/* How about wc. */

#include<stdio.h>



int main (int argc, char *argv[]) {
  FILE *f=stdin;
  int c;
  int nchars=0, nwords=0, nlines=0;
  int lastc=-1;
  if (argc>1) {
    f = fopen (argv[1], "r");
    if (f==NULL) {
      fputs("Cannot open file ",stderr);
      fputs(argv[1],stderr);
      fputc('\n',stderr);
      return 1;
    }
  }
  while ((c = fgetc(f))!=EOF) {
    nchars++;
    if (c=='\r' || (c=='\n' && lastc!='\r')) {
      nlines++;
    } else if ((c==' ') || (c=='\t')) {
      /* nothing */ 
    } else {
      if (lastc==' '
	  || lastc=='\t'
	  || lastc=='\n'
	  || lastc=='\r'
	  || lastc==-1)
	nwords++;
    }
    lastc=c;
  }
  printf("%d %d %d\n",nlines,nwords,nchars);
}

  
    
