#line 189 "list.nw"
 
#line 209 "list.nw"
/* Humans: Please do not read or write this file, instead update list.nw */
#ident "$Id: list.nw,v 1.9 1999/01/15 20:06:53 bradley Exp $"
#line 190 "list.nw"
#ifndef _LIST_DEFINED_
#define _LIST_DEFINED_
 
#line 35 "list.nw"
 
#line 200 "list.nw"
#ifdef __cplusplus
#define EXTERN_C extern "C"
#else
#define EXTERN_C extern
#endif

#line 37 "list.nw"
typedef struct cons_cell LIST;

struct cons_cell {
  void *car;
  LIST *cdr;
};
#line 47 "list.nw"
EXTERN_C LIST *
list_cons (void *car, LIST *cdr );

EXTERN_C void
list_map (LIST *l, void(*f)(void*,void*), void *extra_args);

EXTERN_C void
list_free_cons_cell (LIST *l);
#line 62 "list.nw"
typedef struct alist_cell ALIST;
struct alist_cell {
  const void *key;
  void *value;
  ALIST *next;
};

#define NULL_LIST (0)

EXTERN_C ALIST *
alist_cons (const void *key, void *value, ALIST *next);

EXTERN_C void
alist_map (ALIST *l, void(*f)(const void*,void*,void*), void *extra_args);

typedef int (*ALIST_NEQ_PREDICATE)(const void*,const void*);

#define ALIST_STRCMP_PREDICATE ((ALIST_NEQ_PREDICATE)(strcmp))

EXTERN_C ALIST*
alist_find (ALIST *l, const void *value, ALIST_NEQ_PREDICATE neq_predicate);
#line 193 "list.nw"
#endif
