#line 867 "ydfg-spec.nw"
 
#line 925 "ydfg-spec.nw"
/* Humans: Please do not read or write this file, instead update ydfg.nw */
#ident "$Id: ydfg-spec.nw,v 1.15 1999/03/01 16:05:48 bradley Exp $"
#line 868 "ydfg-spec.nw"
#ifndef _YDFG_DEFINED_
#define _YDFG_DEFINED_
 
#line 76 "ydfg-spec.nw"
 
#line 43 "ydfg-spec.nw"
#define DFG_MAJOR_VERSION 0
#define DFG_MINOR_VERSION 2
#define DFG_IDENT "$Id: ydfg-spec.nw,v 1.15 1999/03/01 16:05:48 bradley Exp $"
#define DFG_IDENT2 "$Revision: 1.15 $"
#line 77 "ydfg-spec.nw"
 
#line 338 "ydfg-spec.nw"
#include"symbols.h"
#include"multiset.h"
#include"list.h"
#include"sexpr.h"
#include<stdio.h>

/* use this as an expression */
#define IGNORE(x) (void)(x) 
/* use this one in an argument list or variable declaration. */
#define IGNORED(var) var __attribute__((unused))
#line 356 "ydfg-spec.nw"
typedef struct dfgedge DFGEDGE;         /* An edge in the graph */
typedef struct dfgnode DFGNODE;         /* A node in the graph */
typedef struct dfgedgename {            /* The symbolic name of an edge */
  SYMBOL     *string;
  int	     offset;
} EDGENAME;
#line 78 "ydfg-spec.nw"
 
#line 888 "ydfg-spec.nw"
#ifdef __cplusplus
#define EXTERN_C extern "C"
#else
#define EXTERN_C extern
#endif
#line 79 "ydfg-spec.nw"
 
#line 368 "ydfg-spec.nw"
EXTERN_C DFGNODE*
cons_dfgnode (SYMBOL *op, SXREF args,
	      const EDGENAME *inputnames, const EDGENAME *outputnames);
#line 405 "ydfg-spec.nw"
/*typedef struct source_variable SOURCE_VARIABLE;*/

EXTERN_C void wire_output_to_input (DFGNODE *from_node, int from_port,
				  DFGNODE *to_node,   int to_port
				  /*,const SOURCE_VARIABLE *value_name*/
				  );
#line 428 "ydfg-spec.nw"
EXTERN_C void
dfgnode_map_over_destinations_of_output (DFGNODE *n,
					 unsigned int output_number,
					 void(*f)(DFGNODE* destnd,unsigned int destport,unsigned int output_arc_number, void*),
					 void*extras);
#line 444 "ydfg-spec.nw"
EXTERN_C void
dfgnode_map_over_sources_of_input (DFGNODE *n,
                                   unsigned int input_number,
                                   void(*f)(DFGNODE*,unsigned int destport,unsigned int input_arc_number, void*),
                                   void*extras);
#line 460 "ydfg-spec.nw"
EXTERN_C const SYMBOL*
dfgnode_opcode (const DFGNODE *n);
#line 469 "ydfg-spec.nw"
EXTERN_C SXREF
dfgnode_arguments (const DFGNODE *n);
#line 477 "ydfg-spec.nw"
EXTERN_C void
dfgnode_set_arguments (DFGNODE *n, const SEXPR *new_args);
#line 486 "ydfg-spec.nw"
EXTERN_C unsigned int
dfgnode_n_outputs (DFGNODE *n);
#line 505 "ydfg-spec.nw"
EXTERN_C unsigned int
dfgnode_n_inputs (DFGNODE *n);
#line 519 "ydfg-spec.nw"
EXTERN_C int
n_output_ports_with_name (const DFGNODE *n, SYMBOL *s);
EXTERN_C int
n_input_ports_with_name (const DFGNODE *n, SYMBOL *s);
#line 531 "ydfg-spec.nw"
EXTERN_C int
input_name_to_number (DFGNODE *n, const SYMBOL *s, int o);
#line 544 "ydfg-spec.nw"
EXTERN_C int
input_name_to_number_checked (DFGNODE *n, const SYMBOL *s, int o);
#line 555 "ydfg-spec.nw"
EXTERN_C int
input_name_to_number_unchecked (DFGNODE *n, const SYMBOL *s, int o);
#line 567 "ydfg-spec.nw"
EXTERN_C void
input_number_to_name (DFGNODE *n, int i, const SYMBOL **s, int *o);
#line 614 "ydfg-spec.nw"
EXTERN_C int
output_name_to_number (DFGNODE *n, const SYMBOL *s, int o);
#line 626 "ydfg-spec.nw"
EXTERN_C int
output_name_to_number_checked (DFGNODE *n, const SYMBOL *s, int o);
#line 636 "ydfg-spec.nw"
EXTERN_C int
output_name_to_number_unchecked (DFGNODE *n, const SYMBOL *s, int o);
#line 647 "ydfg-spec.nw"
EXTERN_C void
output_number_to_name (DFGNODE *n, int i, const SYMBOL **s, int *o);
#line 691 "ydfg-spec.nw"
EXTERN_C void 
edge_number_to_name (const EDGENAME *edgenames, int i, const SYMBOL **s, int *o);
#line 706 "ydfg-spec.nw"
EXTERN_C int
edge_name_to_number (const EDGENAME *edgenames, const SYMBOL *s, int o);
#line 719 "ydfg-spec.nw"
EXTERN_C int
edge_name_to_number_checked (const EDGENAME *edgenames, const SYMBOL *s, int o);
#line 730 "ydfg-spec.nw"
EXTERN_C int
edge_name_to_number_unchecked (const EDGENAME *edgenames, const SYMBOL *s, int o);
#line 743 "ydfg-spec.nw"
EXTERN_C unsigned int
dfgnode_input_arcnumber (DFGNODE *n, unsigned int onum, unsigned int oarcnum);
#line 753 "ydfg-spec.nw"
EXTERN_C unsigned int
dfgnode_output_arcnumber (DFGNODE *n, unsigned int inum, unsigned int iarcnum);
#line 764 "ydfg-spec.nw"
EXTERN_C void
write_top_level_dfg_alist_to_file (FILE *f,
				   ALIST *elts);
#line 782 "ydfg-spec.nw"
EXTERN_C ALIST*
read_top_level_dfg_alist_from_file (FILE *F);
#line 791 "ydfg-spec.nw"
EXTERN_C void
ydfg_write_date_to_file (FILE *f);
#line 871 "ydfg-spec.nw"
#endif
