#line 501 "hashtable.nw"
 
#line 558 "hashtable.nw"
/* Humans: Please do not read or write this file, instead
 * update hashtable.nw */
#ident "$Id: hashtable.nw,v 1.9 1997/06/04 15:22:26 bradley Exp $"
#line 502 "hashtable.nw"
#ifndef _HASHTABLE_DEFINED_
#define _HASHTABLE_DEFINED_
 
#line 43 "hashtable.nw"
 
#line 49 "hashtable.nw"
typedef struct hash_table HASH_TABLE;
typedef const void *KEY;
typedef int (*COMPARISON_FUN)(KEY,KEY);
typedef unsigned int (*HASH_FUN)(KEY);
#line 44 "hashtable.nw"
 
#line 548 "hashtable.nw"
#ifdef __cplusplus
#define EXTERN_C extern "C"
#else
#define EXTERN_C extern
#endif
#line 45 "hashtable.nw"
 
#line 57 "hashtable.nw"
EXTERN_C HASH_TABLE*
hash_table_create (int n_elts_hint,
		   COMPARISON_FUN cfun,
		   HASH_FUN hfun);
#line 80 "hashtable.nw"
EXTERN_C void
hash_table_free (HASH_TABLE *tbl);
#line 91 "hashtable.nw"
EXTERN_C void
hash_table_clear (HASH_TABLE *tbl);
#line 100 "hashtable.nw"
EXTERN_C int
hash_table_lookup (HASH_TABLE *tbl, const void *key,
		   KEY *stored_key, void **stored_value);
#line 116 "hashtable.nw"
EXTERN_C void hash_table_store    (HASH_TABLE *tbl, KEY key, void *value);
#line 505 "hashtable.nw"
 
#line 143 "hashtable.nw"
EXTERN_C int
hash_table_compare_eq (const void *a, const void *b);
#line 151 "hashtable.nw"
EXTERN_C unsigned int
hash_table_hashfun_eq (const void *a);
#line 184 "hashtable.nw"
EXTERN_C unsigned int
hashfun_add_byte (unsigned int byte, unsigned int oldhash);
#line 506 "hashtable.nw"
#endif
