#line 876 "ydfg-spec.nw"
 
#line 925 "ydfg-spec.nw"
/* Humans: Please do not read or write this file, instead update ydfg.nw */
#ident "$Id: ydfg-spec.nw,v 1.15 1999/03/01 16:05:48 bradley Exp $"
#line 877 "ydfg-spec.nw"
#ifndef _SEXPR_DEFINED_
#define _SEXPR_DEFINED_
 
#line 163 "ydfg-spec.nw"
 
#line 170 "ydfg-spec.nw"
#include<stdio.h>
#include<malloc.h>
#include"symbols.h"
#include"numbering.h"

typedef struct sexpr SEXPR;
typedef const SEXPR *SXREF;
typedef enum {
  SEXPR_TAG_NULL, SEXPR_TAG_CONS, SEXPR_TAG_SYMBOL, SEXPR_TAG_INT} SEXPR_TAG;

#define SEXPR_NULL 0

typedef struct ydfgfile YDFGFILE;
struct ydfgfile {
  FILE *f;
  int line,charinline,charinfile;
  int eof;
  NUM2OBJ *table;
};
#line 164 "ydfg-spec.nw"
 
#line 888 "ydfg-spec.nw"
#ifdef __cplusplus
#define EXTERN_C extern "C"
#else
#define EXTERN_C extern
#endif
#line 165 "ydfg-spec.nw"
 
#line 219 "ydfg-spec.nw"
EXTERN_C SXREF sexpr_cons (SXREF car, SXREF cdr);
EXTERN_C SXREF sexpr_symbol (const SYMBOL *s);
EXTERN_C SXREF sexpr_int (int i);
EXTERN_C SEXPR_TAG sexpr_tag (SXREF s);
EXTERN_C int sexpr_cons_p (SXREF s);
EXTERN_C int sexpr_symbol_p (SXREF s);
EXTERN_C int sexpr_int_p (SXREF );
EXTERN_C SXREF sexpr_get_car (SXREF s);
EXTERN_C SXREF sexpr_get_cdr (SXREF s);
EXTERN_C const SYMBOL* sexpr_get_symbol (SXREF s);
EXTERN_C int sexpr_get_int (SXREF s);

EXTERN_C void sexpr_write (FILE *f, SXREF s);
EXTERN_C SXREF sexpr_read (YDFGFILE *f); 
#line 237 "ydfg-spec.nw"
YDFGFILE*
ydfg_setup_to_read_file (FILE *f);

int
ydfg_getc (YDFGFILE *yf);

int
ydfg_ungetc (int c, YDFGFILE *yf);
#line 194 "ydfg-spec.nw"
EXTERN_C SXREF
sexpr_list1 (SXREF a);

EXTERN_C SXREF
sexpr_list2 (SXREF a, SXREF b);

EXTERN_C SXREF
sexpr_list3 (SXREF a, SXREF b, SXREF c);

EXTERN_C SXREF
sexpr_list4 (SXREF a, SXREF b, SXREF c, SXREF d);

EXTERN_C SXREF
sexpr_list5 (SXREF a, SXREF b, SXREF c, SXREF d, SXREF e);

EXTERN_C SXREF
sexpr_list6 (SXREF a, SXREF b, SXREF c, SXREF d, SXREF e, SXREF f);

EXTERN_C SXREF
sexpr_list7 (SXREF a, SXREF b, SXREF c, SXREF d, SXREF e, SXREF f, SXREF g);
#line 880 "ydfg-spec.nw"
#endif
