#line 502 "symbols.nw"
/* Humans: Please do not read or write this file, instead update symbols.nw */
#ident "$Id: symbols.nw,v 1.15 1999/01/30 10:09:59 bradley Exp $"
#line 39 "symbols.nw"
                   /* Stuff I put at the beginning of every outputted .c and .h file */

#ifndef _SYMBOL_DEFINED_
#define _SYMBOL_DEFINED_

typedef struct symbol SYMBOL;

#line 491 "symbols.nw"
#ifdef __cplusplus
#define EXTERN_C extern "C"
#else
#define EXTERN_C extern
#endif
#line 55 "symbols.nw"
EXTERN_C SYMBOL* make_symbol(const char *sym);
#line 73 "symbols.nw"
EXTERN_C unsigned int symbol_length(const SYMBOL *sym);
#line 84 "symbols.nw"
EXTERN_C char symbol_fetch_char(const SYMBOL *sym, unsigned int offset);
#line 94 "symbols.nw"
EXTERN_C void symbol_show(const SYMBOL *sym, char *string, unsigned int maxlen);
#line 111 "symbols.nw"
EXTERN_C int symbol_string_compare (const SYMBOL *sym, const char *str);
#line 162 "symbols.nw"
unsigned int symbol_hash_fun (const void *str_as_void);

#line 49 "symbols.nw"
#endif
